"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const Container_1 = require("./Container");
function Inject(name) {
    return (target, propertyKey) => {
        const metadata = Reflect.getMetadata('design:type', target, propertyKey);
        const propertyType = (metadata && metadata.prototype && metadata.prototype.constructor)
            ? metadata.prototype.constructor.name : null;
        const serviceName = (name || propertyType) || propertyKey;
        SimpleDI.addInjectProperty(target, propertyKey, serviceName);
    };
}
exports.Inject = Inject;
class SimpleDI {
    static getContainer() {
        if (!SimpleDI.container) {
            SimpleDI.container = new Container_1.Container();
        }
        return SimpleDI.container;
    }
    static register(...serviceClasses) {
        this.getContainer().register(...serviceClasses);
    }
    static registerByName(name, serviceClass) {
        this.getContainer().registerByName(name, serviceClass);
    }
    static addInjectProperty(target, propertyKey, serviceName = propertyKey) {
        this.getContainer().addInjectProperty(target, propertyKey, serviceName);
    }
    static get(name) {
        return this.getContainer().get(name);
    }
    static getByType(c) {
        return this.getContainer().getByType(c);
    }
    static getAll() {
        return this.getContainer().getAll();
    }
    constructor() { }
}
exports.SimpleDI = SimpleDI;
exports.default = SimpleDI;
//# sourceMappingURL=SimpleDI.js.map